; 2D in 3D

.Setup2D3D

	campivot=CreatePivot()
	cam=CreateCamera(campivot)
	PositionEntity cam,0,0,400
	PointEntity cam,campivot
	PositionEntity campivot,400,300,0
	RotateEntity cam,180,0,0
	AmbientLight 255,255,255

	
CameraProjMode cam,2
CameraZoom cam,0.0025
CameraClsMode cam,0,1
	
	Type font
		Field width[128]
		Field tex
		Field wide
		Field high
	End Type

	Type sprite
		Field ent
		Field width#
		Field height#
		Field img,iw,ih,tex
	End Type

	Global Dupe
	
	Global lf,fc
	Dim Framerate(10)
	Global NextFrame
	
	Global SpriteN=1
	Global MaxSprites=2500
	
	Global SpriteSizeX#=32,SpriteSizeY#=32
	Global SpriteRot#=0
	Global SpriteAlpha#=1
	Global SpriteRed=255,SpriteGreen=255,SpriteBlue=255
	
	Dim Obj.sprite(MaxSprites)
	

	obj.sprite(0)=Make1Sprite.sprite(NoTexture,32,32)
	
	For n=1 To MaxSprites
		obj.sprite(n)=MakeSprite.sprite()
	Next

	
	
	CLS3d
		
Return



Function SetColor(r,g,b,a#=1)
	SpriteRed=r
	SpriteGreen=g
	SpriteBlue=b
	SpriteAlpha=a
End Function

Function SetCol(r,g,b,a#=1)
	SpriteRed=r
	SpriteGreen=g
	SpriteBlue=b
	SpriteAlpha=a
End Function

Function SetRot(r#=0)
	SpriteRot#=r
End Function

Function SetSize(x#=32,y#=320000)
	SpriteSizeX#=x
	SpriteSizeY#=y
	If y=320000 Then SpriteSizeY=x
End Function

Function SetClear()
	SpriteRed=255:SpriteGreen=255:SpriteBlue=255:SpriteAlpha=1
	SpriteSizeX#=32:SpriteSizeY#=32:SpriteRot=0
End Function

Function DrawSprite(img,x,y,frm=0)
x=x+(obj(SpriteN)\width/2)

x=x+((SpriteSizeX#/obj(SpriteN)\width)*16)-16

y=y+(obj(SpriteN)\height/2)

y=y+((SpriteSizeY#/obj(SpriteN)\height)*16)-16

	If SpriteN<MaxSprites
		SpriteN=SpriteN+1
		EntityTexture obj(SpriteN)\ent,img,frm
		PositionEntity obj(SpriteN)\ent,x,y,(Float(SpriteN)/10)-250
		ScaleEntity obj(SpriteN)\ent,SpriteSizeX#/obj(SpriteN)\width,SpriteSizeY#/obj(SpriteN)\height,1
		RotateEntity obj(SpriteN)\ent,0,0,SpriteRot,1
		EntityAlpha obj(SpriteN)\ent,SpriteAlpha#
		EntityColor obj(SpriteN)\ent,SpriteRed,SpriteGreen,SpriteBlue
	EndIf
End Function




Function PutTile(layer.sprite,image,x,y,frame=0)
	CopyRect 0,0,layer\iw,layer\ih,x*layer\iw,y*layer\ih,ImageBuffer(image,frame),TextureBuffer(layer\tex)
End Function

Function DrawLayer(layer.sprite,x,y)
		EntityTexture layer\ent,layer\tex
		PositionEntity layer\ent,x+1024,y+1024,((Float(SpriteN)/10)-0.05)-250
		RotateEntity layer\ent,0,0,SpriteRot,1
		EntityAlpha layer\ent,SpriteAlpha
		EntityColor layer\ent,SpriteRed,SpriteGreen,SpriteBlue
End Function



Function CLS3d(a=1,b=1)
	If a=1 Then Cls
	
	If b=1
		While (SpriteN>0)
			EntityAlpha obj(SpriteN)\ent,0
			SpriteN=SpriteN-1
		Wend 
	EndIf
	If b=0 Then SpriteN=1
End Function





Function Make1Sprite.sprite(img,w=16,h=16,frm=0,parent=0)
	w=w/2
	h=h/2
	a.sprite=New sprite
	
	dupe=CreateMesh()
		Surface=CreateSurface(dupe)
		    AddVertex surface,-w,-h,0,0,0
		    AddVertex surface,w,-h,0,1,0
		    AddVertex surface,w,h,0,1,1
		    AddVertex surface,-w,h,0,0,1 
		    AddTriangle surface,0,1,2
		    AddTriangle surface,0,2,3
		UpdateNormals dupe
		EntityColor dupe,255,0,255
		PositionEntity dupe,0,0,800

	a\ent=CopyEntity(dupe,parent)
	a\width=32
	a\height=32
	FreeEntity dupe
	
	
	Return a.sprite
End Function


Function MakeSprite.sprite()

	a.sprite=New sprite
	b.sprite=First sprite
	a\ent=CopyEntity(b\ent)
	a\width=32
	a\height=32

	PositionEntity a\ent,0,0,800
	Return a.sprite
End Function



Function MakeLayer.sprite(w=32,h=32)
	a.sprite=New sprite
	b.sprite=First sprite
	
	a\ent=CopyEntity(b\ent)
	ScaleEntity a\ent,64,64,1
	
	tsize=1024
	
	a\width=tsize
	a\height=tsize
	
	a\iw=w
	a\ih=h
	
	a\img=CreateImage(tsize,tsize)
	a\tex=CreateTexture(tsize,tsize)
	
	PositionEntity a\ent,0,0,0

	Return a.sprite
End Function







Function LoadImgFont.font(in$)
	ThisFont.Font=New font
	quicky=ReadFile(in$)
	
	ThisFont\wide=ReadByte(quicky)
	ThisFont\high=ReadByte(quicky)
	
	ThisFont\tex=CreateTexture(ThisFont\wide,ThisFont\high,2,96)
	
	For n=32 To 127
		ThisFont\width[n]=ReadByte(quicky)

		For y=0 To ThisFont\high-1
			For x=0 To ThisFont\wide-1

				r=ReadByte(quicky)
				g=ReadByte(quicky)
				b=ReadByte(quicky)
				a=ReadByte(quicky)
				
				c=(255 Shl 24)+(r Shl 16)+(g Shl 8)+b
				If a<125 Then c=0 Shl 24
				WritePixel(x,y,c, TextureBuffer(thisfont\tex,n-32))
			Next
		Next
	Next
	
	
	
	
	CloseFile quicky
	
	Return ThisFont.font
	
End Function


Function DrawText(ThisFont.font,x,y,st$,justify=0)
w#=SpriteSizeX
h#=SpriteSizeY

SpriteSizeX=ThisFont\wide:SpriteSizeY=ThisFont\high
If justify=0 Or justify=1
	For n=1 To Len(st$)
		If x>-32 And x<832 And y>-32 And y<623 And justify=0 Then DrawSprite ThisFont\tex,x,y,Abs((Asc(Mid$(st$,n,1)) Mod 128)-32)
		If justify=0 Then x=x+ThisFont\width[Asc(Mid$(st$,n,1))]
		If justify=1 Then x=x+(ThisFont\width[Asc(Mid$(st$,n,1))])/2
	Next
EndIf

If justify=1 Or justify=2
	For n=Len(st$) To 1 Step -1
		x=x-ThisFont\width[Asc(Mid$(st$,n,1))]
		If x>-32 And x<832 And y>-32 And y<623 Then DrawSprite ThisFont\tex,x,y,Abs((Asc(Mid$(st$,n,1)) Mod 128)-32)
	Next
EndIf


SpriteSizeX=w
SpriteSizeY=h
Return x
End Function


Function DrawLetter(ThisFont.font,x,y,ch)
w#=SpriteSizeX
h#=SpriteSizeY
SpriteSizeX=ThisFont\wide:SpriteSizeY=ThisFont\high
	If x>-32 And x<832 And y>-32 And y<623 Then DrawSprite ThisFont\tex,x,y,Abs((ch Mod 128)-32)
SpriteSizeX=w
SpriteSizeY=h
Return ThisFont\width[ch]
End Function







Function Keep60fps()
	fc=0
	ttr=MilliSecs()-lf
	If ttr=0 Then ttr=1
	fps=(1000/ttr)
	
	For n=9 To 1 Step -1
		framerate(n)=framerate(n-1)
		fc=fc+framerate(n)
	Next
	
	framerate(0)=fps
	fc=fc+fps
	
	lf=MilliSecs()
	If nextframe>MilliSecs() Then Repeat:Until nextframe<=MilliSecs()
	nextframe=MilliSecs()+16

End Function



Function Render2D3D()
	RenderWorld
End Function


Function RoughFPS()
	Return fc/10
End Function